%define	rname		PersistentPerl
%define	rversion	2.22
%define	release		5mdk

#Apache2 Module-Specific definitions
%define mod_version	%{rversion}
%define mod_name	mod_persistentperl
%define mod_conf	99_%{mod_name}.conf
%define mod_so		%{mod_name}.so

#New ADVX macros
%define ADVXdir %{_datadir}/ADVX
%{expand:%(cat %{ADVXdir}/ADVX-build)}
%{expand:%%global ap_version %(%{apxs} -q ap_version)}

#Standard ADVX requires
Prereq:			%{ap_name} = %{ap_version}
Prereq:			%{ap_name}-conf
BuildRequires:  	ADVX-build >= 1.2
BuildRequires:  	%{ap_name}-devel >= 2.0.43-5mdk

Summary:		Speed up perl scripts by running them persistently.
Name:			perl-%{rname}
Version:		%{rversion}
Release:		%{release}
URL:			http://daemoninc.com/PersistentPerl/
License:		GPL
Source0:		%{rname}-%{rversion}.tar.bz2
Source1:		%{mod_conf}.bz2
Source2:		test.perperl.bz2
Group:			Development/Perl
Requires:		perl
BuildRequires:		perl-devel
BuildRequires:		perl-CGI
BuildRoot:		%{_tmppath}/%{rname}-%{rversion}-root

%description
PersistentPerl is a way to run perl scripts persistently, which 
can make them run much more quickly. A script can be made to to 
run persistently by changing the interpreter line at the top of 
the script from:

  "#!/usr/bin/perl"

to

  "#!/usr/bin/perperl"

After the script is initially run, instead of exiting, the perl 
interpreter is kept running. During subsequent runs, this 
interpreter is used to handle new executions instead of starting a
new perl interpreter each time. A very fast frontend program, 
written in C, is executed for each request. This fast frontend 
then contacts the persistent Perl process, which is usually 
already running, to do the work and return the results.

By default each perl script runs in its own Unix process, so one
perl script can't interfere with another. Command line options
can also be used to deal with programs that have memory leaks or
other problems that might keep them from otherwise running
persistently.

PersistentPerl can be used to speed up perl CGI scripts. It
conforms to the CGI specification, and does not run perl code
inside the web server. Since the perl interpreter runs outside
the web server, it can't cause problems for the web server itself.

PersistentPerl also provides an Apache module so that under the
Apache web server, scripts can be run without the overhead of
doing a fork/exec for each request. With this module a small
amount of frontend code is run within the web server - the perl
interpreters still run outside the server.

SpeedyCGI and PersistentPerl are currently both names for the same
code. SpeedyCGI was the original name, but because people weren't
sure what it did, the name PersistentPerl was picked as an alias.
At some point SpeedyCGI will probably be replaced by
PersistentPerl, or become a sub-class of PersistentPerl to avoid
always having two distributions.


%package -n		%{ap_name}-%{mod_name}
Summary:		Mod_persistentperl is a DSO module for the %{ap_name} Web server.
Version:		%{ap_version}_%{rversion}
Group:			System/Servers
Requires:		%{ap_name} = %{ap_version}
Requires:		%{ap_name}-conf
Requires:		perl-%{rname} = %{rversion}

%description -n		%{ap_name}-%{mod_name}
Mod_persistentperl is a DSO module for the %{ap_name} Web server.

%prep
%setup -q -n %{rname}-%{rversion}
# perl path hack
find . -type f | xargs %{__perl} -p -i -e "s|^#\!/usr/local/bin/perl|#\!/usr/bin/perl|g"

bzcat %{SOURCE2} > test.perperl

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor PREFIX=%{_prefix} </dev/null
%{__make}
#%{__make} test

# make the apache2 module
pushd mod_persistentperl2
    %{__perl} Makefile.PL
    %{__perl} -p -i -e "s|^APXS=.*|APXS=%{apxs}|g" Makefile
    %{__make}
    cp -rp .libs ../
popd

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot} 

%{__make} PREFIX=%{buildroot}/%{_prefix} install

install -d %{buildroot}/var/lib/%{mod_name}
install -d %{buildroot}/var/www/perperl
install -m0755 test.perperl %{buildroot}/var/www/perperl/test.perperl

install -d %{buildroot}%{ap_webdoc}
ln -s ../../../..%{_docdir}/%{ap_name}-%{mod_name}-%{ap_version}_%{rversion} \
    %{buildroot}%{ap_webdoc}/%{ap_name}-%{mod_name}-%{ap_version}_%{rversion}

cat > HEADER.html << EOF
Click <a href="http://localhost/perperl/test.perperl">here</a> to run the test.perperl script.
EOF

%ADVXinstlib
%ADVXinstconf %{SOURCE1} %{mod_conf}

%post -n		%{ap_name}-%{mod_name}
%ADVXpost

%postun -n		%{ap_name}-%{mod_name}
%ADVXpost

%clean 
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot} 

%files
%defattr(-,root,root)
%doc Changes README
%{_bindir}/*
%{perl_vendorlib}/PersistentPerl.pm

%files -n		%{ap_name}-%{mod_name}
%defattr(-,root,root)
%doc docs contrib util README.html HEADER.html
%config(noreplace) %{ap_confd}/%{mod_conf}
%{ap_extralibs}/%{mod_so}
/var/www/perperl/test.perperl
%dir %attr(0755,apache,apache) /var/lib/%{mod_name}
%{ap_webdoc}/*

%changelog
* Sun Aug 01 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.22-5mdk
- remove redundant provides
- built for apache 2.0.50

* Mon Jun 14 2004 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.22-4mdk
- built for apache 2.0.49

* Wed Nov 12 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.22-3mdk
- rebuilt against perl-5.8.2

* Wed Nov 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.22-2mdk
- built for apache 2.0.48
- deactivate make test for now, it hangs forever...

* Sun Oct 12 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.22-1mdk
- 2.22, finally compiles against apache 2.0.47
- make it work out of the box
- run make test as it seems to work now
- misc spec file fixes

* Thu Jun 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.21-3mdk
- rebuild for apache2 v2.0.46

* Fri May 23 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.21-2mdk
- fix description
- added a simple test script (http://localhost/cgi-bin/test.perperl)
- misc spec file fixes

* Thu May 22 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.21-1mdk
- initial cooker contrib.
